import Element from './Element';
/**
 * Class list.
 */
export default class ClassList {
    private _ownerElement;
    /**
     * Adds class names.
     *
     * @param ownerElement Owner element.
     */
    constructor(ownerElement: Element);
    /**
     * Adds class names.
     *
     * @param classNames Class names.
     */
    add(...classNames: string[]): void;
    /**
     * Adds class names.
     *
     * @param classNames Class names.
     */
    remove(...classNames: string[]): void;
    /**
     * Check if the list contains a class.
     *
     * @param className Class name.
     * @returns TRUE if it contains.
     */
    contains(className: string): boolean;
    /**
     * Toggle a class name.
     *
     * @param className A string representing the class name you want to toggle.
     * @param force If included, turns the toggle into a one way-only operation. If set to `false`, then class name will only be removed, but not added. If set to `true`, then class name will only be added, but not removed.
     * @returns A boolean value, `true` or `false`, indicating whether class name is in the list after the call or not.
     */
    toggle(className: string, force?: boolean): boolean;
}
